cookutils annotate cook @ rev 284

Add GENERIC_MENUS option
author Eric Joseph-Alexandre <erjo@slitaz.org>
date Sun Feb 12 22:18:30 2012 +0100 (2012-02-12)
parents 1ac02a8b311a
children 7b46752d788a
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@172 19 # Old style compatibility
pankso@172 20 SOURCES_REPOSITORY=$SRC
pankso@172 21
pankso@1 22 #
pankso@1 23 # Functions
pankso@1 24 #
pankso@1 25
pankso@1 26 usage() {
pankso@1 27 cat << EOT
pankso@1 28
pankso@147 29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
pankso@1 30
pankso@1 31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
paul@214 32 usage|help $(gettext "Display this short usage.")
paul@214 33 setup $(gettext "Setup your build environment.")
paul@214 34 test $(gettext "Test environment and cook a package.")
paul@214 35 list-wok $(gettext "List packages in the wok.")
paul@214 36 search $(gettext "Simple packages search function.")
paul@214 37 new $(gettext "Create a new package with a receipt".)
paul@214 38 list $(gettext "Cook a list of packages.")
paul@214 39 clean-wok $(gettext "Clean-up all packages files.")
paul@214 40 clean-src $(gettext "Clean-up all packages sources.")
pankso@239 41 pkgdb $(gettext "Create packages DB lists and flavors.")
pankso@1 42
pankso@1 43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
paul@214 44 --clean|-c Cook : $(gettext "clean the package in the wok.")
paul@214 45 --install|-i Cook : $(gettext "cook and install the package.")
paul@214 46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
paul@214 47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
paul@214 48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@230 49 --interactive|-x New : $(gettext "create a receipt interactively.")
pankso@230 50 --wok|-w Setup: $(gettext "clone the cooking wok from Hg repo.")
pankso@230 51 --stable Setup: $(gettext "clone the stable wok from Hg repo.")
pankso@230 52 --undigest Setup: $(gettext "clone the undigest wok from Hg repo.")
pankso@239 53 --flavors Pkgdb: $(gettext "create up-to-date flavors files.")
pankso@1 54
pankso@1 55 EOT
pankso@1 56 exit 0
pankso@1 57 }
pankso@1 58
paul@62 59 # Be sure we're root.
pankso@1 60 check_root() {
pankso@1 61 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 62 }
pankso@1 63
pankso@1 64 separator() {
pankso@1 65 echo "================================================================================"
pankso@1 66 }
pankso@1 67
pankso@1 68 status() {
pankso@1 69 echo -en "\\033[70G[ "
pankso@1 70 if [ $? = 0 ]; then
pankso@1 71 echo -en "\\033[1;32mOK"
pankso@1 72 else
pankso@1 73 echo -en "\\033[1;31mFailed"
pankso@1 74 fi
pankso@1 75 echo -e "\\033[0;39m ]"
pankso@1 76 }
pankso@1 77
pankso@13 78 # Log activities, we want first letter capitalized.
pankso@9 79 log() {
pankso@27 80 grep ^[A-Z] | \
pankso@9 81 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 82 }
pankso@9 83
paul@62 84 # We don't want these escapes in web interface.
pankso@1 85 clean_log() {
pankso@1 86 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 87 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 88 }
pankso@1 89
pankso@23 90 # Log broken packages.
pankso@23 91 broken() {
pankso@74 92 if ! grep -q "^$pkg$" $broken; then
pankso@74 93 echo "$pkg" >> $broken
pankso@74 94 fi
pankso@23 95 }
pankso@23 96
paul@62 97 # Be sure package exists in wok.
pankso@1 98 check_pkg_in_wok() {
pankso@1 99 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 100 gettext -e "\nUnable to find package in the wok:"
pankso@1 101 echo -e " $pkg\n" && exit 1
pankso@1 102 fi
pankso@1 103 }
pankso@1 104
pankso@9 105 if_empty_value() {
pankso@9 106 if [ -z "$value" ]; then
pankso@9 107 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 108 exit 1
pankso@9 109 fi
pankso@9 110 }
pankso@9 111
paul@62 112 # Initialize files used in $CACHE
pankso@52 113 init_db_files() {
pankso@52 114 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 115 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 116 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 117 for f in $activity $command $broken $blocked
pankso@52 118 do
pankso@52 119 touch $f
pankso@52 120 done
pankso@52 121 }
pankso@52 122
paul@62 123 # QA: check a receipt consistency before building.
pankso@9 124 receipt_quality() {
pankso@9 125 gettext -e "QA: checking package receipt...\n"
pankso@9 126 unset online
pankso@9 127 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 128 online="online"
pankso@9 129 fi
pankso@9 130 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 131 do
pankso@9 132 unset value
pascal@279 133 value="$(. $receipt ; eval echo \$$var)"
pankso@9 134 case "$var" in
pankso@9 135 PACKAGE|VERSION|SHORT_DESC)
pankso@9 136 if_empty_value ;;
pankso@9 137 CATEGORY)
pankso@9 138 [ -z "$value" ] && value="empty"
pankso@9 139 valid="base-system x-window utilities network graphics \
pankso@9 140 multimedia office development system-tools security games \
pankso@9 141 misc meta non-free"
pankso@9 142 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 143 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 144 exit 1
pankso@9 145 fi ;;
pankso@9 146 WEB_SITE)
paul@62 147 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 148 # Break also if we're not online. Here error is not fatal.
pankso@9 149 if_empty_value
pankso@9 150 [ -z "$online" ] || break
pankso@199 151 if ! busybox wget -T 12 -s $value 2>/dev/null; then
pankso@61 152 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 153 fi ;;
pankso@9 154 esac
pankso@9 155 done
pankso@9 156 }
pankso@9 157
pankso@9 158 # Executed before sourcing a receipt.
pankso@9 159 unset_receipt() {
pankso@9 160 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 161 }
pankso@9 162
paul@62 163 # Paths used in receipt and by cook itself.
pankso@1 164 set_paths() {
pankso@1 165 pkgdir=$WOK/$PACKAGE
pankso@1 166 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 167 taz=$pkgdir/taz
pankso@44 168 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 169 fs=$pack/fs
pankso@1 170 stuff=$pkgdir/stuff
pankso@1 171 install=$pkgdir/install
pankso@1 172 if [ "$WANTED" ]; then
pankso@1 173 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 174 install=$WOK/$WANTED/install
pankso@121 175 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 176 fi
paul@243 177 # Kernel version is set from linux-api-headers since it is part of toolchain.
pankso@232 178 if [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
pankso@232 179 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d '"' -f 2)
pankso@232 180 fi
pankso@9 181 # Old way compatibility.
pankso@1 182 _pkg=$install
pankso@1 183 }
pankso@1 184
pankso@144 185 # Create source tarball when URL is a SCM.
pankso@144 186 create_tarball() {
pankso@144 187 gettext "Creating tarball: "; echo "$tarball"
pankso@162 188 if [ "$LZMA_SRC" ]; then
pankso@162 189 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
pankso@162 190 else
pankso@162 191 tar cjf $tarball $pkgsrc || exit 1
pankso@162 192 mv $tarball $SRC && rm -rf $pkgsrc
pankso@162 193 fi
pankso@144 194 }
pankso@144 195
pankso@145 196 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 197 # tarball here.
pankso@1 198 get_source() {
pankso@115 199 pwd=$(pwd)
pankso@144 200 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 201 tarball=$pkgsrc.tar.bz2
pankso@162 202 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
pankso@9 203 case "$WGET_URL" in
pankso@145 204 http://*|ftp://*)
pankso@9 205 # Busybox Wget is better!
pascal@268 206 busybox wget -T 60 -c -O $SRC/$TARBALL $WGET_URL || \
pankso@145 207 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@145 208 https://*)
pankso@250 209 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
pankso@15 210 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 211 hg*|mercurial*)
pankso@29 212 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 213 url=${WGET_URL#hg|}
pankso@9 214 else
pankso@9 215 url=${WGET_URL#mercurial|}
pankso@9 216 fi
pankso@61 217 gettext -e "Getting source from Hg...\n"
pankso@61 218 echo "URL: $url"
pankso@9 219 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@246 220 if [ "$BRANCH" ]; then
pankso@246 221 echo "Hg branch: $BRANCH"
pankso@246 222 hg clone $url --rev $BRANCH $pkgsrc || \
pankso@246 223 (echo "ERROR: hg clone $url --rev $BRANCH" && exit 1)
pankso@246 224 else
pankso@246 225 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@246 226 fi
pankso@255 227 rm -rf $pkgsrc/.hg
pankso@144 228 create_tarball ;;
pankso@9 229 git*)
pankso@61 230 url=${WGET_URL#git|}
pankso@61 231 gettext -e "Getting source from Git...\n"
pankso@61 232 echo "URL: $url"
pankso@64 233 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 234 if [ "$BRANCH" ]; then
pankso@146 235 echo "Git branch: $BRANCH"
pankso@64 236 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 237 fi
pankso@144 238 create_tarball ;;
pankso@144 239 cvs*)
pankso@144 240 url=${WGET_URL#cvs|}
pankso@144 241 mod=$PACKAGE
pankso@144 242 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 243 gettext -e "Getting source from CVS...\n"
pankso@144 244 echo "URL: $url"
pankso@146 245 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
pankso@144 246 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 247 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 248 create_tarball ;;
pankso@69 249 svn*|subversion*)
pankso@159 250 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
pankso@146 251 url=${WGET_URL#svn|}
pankso@146 252 else
pankso@146 253 url=${WGET_URL#subversion|}
pankso@146 254 fi
pankso@146 255 gettext -e "Getting source from SVN...\n"
pankso@146 256 echo "URL: $url"
pankso@161 257 if [ "$BRANCH" ]; then
pankso@161 258 echo t | svn co $url -r $BRANCH $pkgsrc
pankso@161 259 else
pankso@161 260 echo t | svn co $url $pkgsrc
pankso@161 261 fi
pankso@146 262 create_tarball ;;
pankso@9 263 *)
pankso@9 264 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 265 tee -a $LOGS/$PACKAGE.log
pankso@9 266 exit 1 ;;
pankso@9 267 esac
pankso@1 268 }
pankso@1 269
pankso@9 270 # Extract source package.
pankso@1 271 extract_source() {
pankso@177 272 if [ ! -s "$SRC/$TARBALL" ]; then
pankso@177 273 local url
pankso@177 274 url="http://mirror.slitaz.org/sources/packages"
pankso@177 275 url=$url/${TARBALL:0:1}/$TARBALL
pankso@177 276 gettext "Getting source from mirror:"; echo " $url"
pankso@177 277 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
pankso@177 278 fi
pankso@1 279 gettext "Extracting:"; echo " $TARBALL"
pankso@1 280 case "$TARBALL" in
pankso@120 281 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@178 282 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 283 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 284 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 285 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 286 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 287 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 288 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@238 289 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
pankso@191 290 *) cp $SRC/$TARBALL $(pwd) ;;
pankso@1 291 esac
pankso@1 292 }
pankso@1 293
pankso@9 294 # Display cooked package summary.
pankso@1 295 summary() {
pankso@1 296 cd $WOK/$pkg
pankso@1 297 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 298 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 299 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 300 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 301 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 302 sec=$time
pascal@280 303 div=$(( ($time + 30) / 60))
pankso@112 304 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 305 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 306 separator
pankso@67 307 [ "$prod" ] && echo "Produced : $prod"
pankso@1 308 cat << EOT
pankso@1 309 Packed : $fs
pankso@1 310 Compressed : $size
pankso@18 311 Files : $files
pankso@102 312 Cook time : ${sec}s $min
pankso@18 313 Cook date : $cookdate
pankso@1 314 $(separator)
pankso@1 315 EOT
pankso@1 316 }
pankso@1 317
paul@62 318 # Display debugging error info.
pankso@15 319 debug_info() {
pankso@17 320 echo -e "\nDebug information"
pankso@15 321 separator
pankso@48 322 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 323 for error in \
pankso@77 324 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 325 "error:" "fatal error:"
pankso@34 326 do
pankso@34 327 fgrep "$error" $LOGS/$pkg.log
pankso@34 328 done
pankso@15 329 separator && echo ""
pankso@15 330 }
pankso@15 331
pankso@1 332 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 333 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 334 copy_generic_files()
pankso@1 335 {
pankso@1 336 # $LOCALE is set in cook.conf
pankso@281 337 if [ "$LOCALE" ]; then
pankso@260 338 if [ -d "$install/usr/share/locale" ]; then
pankso@1 339 mkdir -p $fs/usr/share/locale
pankso@1 340 for i in $LOCALE
pankso@1 341 do
pankso@260 342 if [ -d "$install/usr/share/locale/$i" ]; then
pankso@260 343 cp -a $install/usr/share/locale/$i $fs/usr/share/locale
pankso@1 344 fi
pankso@1 345 done
pankso@1 346 fi
pankso@1 347 fi
pankso@1 348
pankso@1 349 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 350 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@260 351 if [ -d "$install/usr/share/pixmaps" ]; then
pankso@1 352 mkdir -p $fs/usr/share/pixmaps
pankso@260 353 cp -a $install/usr/share/pixmaps/$PACKAGE.png \
pankso@281 354 $fs/usr/share/pixmaps 2>/dev/null || continue
pankso@260 355 cp -a $install/usr/share/pixmaps/$PACKAGE.xpm \
pankso@281 356 $fs/usr/share/pixmaps 2>/dev/null || continue
pankso@1 357 fi
pankso@1 358
pankso@1 359 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 360 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 361 mkdir -p $fs/usr/share/pixmaps
pankso@1 362 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 363 fi
pankso@1 364 fi
pankso@1 365
pankso@1 366 # Desktop entry (.desktop).
erjo@284 367 # Generic desktop entry copy can be disabled with GENERIC_MENUS="no"
erjo@284 368 if [ "$GENERIC_MENUS" != "no" ]; then
erjo@284 369 if [ -d "$install/usr/share/applications" ] && [ "$WANTED" == "" ]; then
erjo@284 370 cp -a $install/usr/share/applications $fs/usr/share
erjo@284 371 fi
pankso@1 372 fi
pankso@1 373
pankso@1 374 # Homemade desktop file(s) can be in stuff.
pankso@1 375 if [ -d "$stuff/applications" ]; then
pankso@1 376 mkdir -p $fs/usr/share
pankso@1 377 cp -a $stuff/applications $fs/usr/share
pankso@1 378 fi
pankso@1 379 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 380 mkdir -p $fs/usr/share/applications
pankso@1 381 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 382 fi
pankso@1 383 }
pankso@1 384
pankso@67 385 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 386 # as removing uneeded files like in Python packages.
pankso@1 387 strip_package()
pankso@1 388 {
pankso@67 389 gettext "Executing strip on all files..."
pankso@1 390 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 391 do
pankso@1 392 if [ -d "$dir" ]; then
pankso@1 393 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 394 fi
pankso@1 395 done
pankso@1 396 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 397 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 398 status
pankso@67 399
pankso@117 400 # Remove Python .pyc and .pyo from packages.
pankso@150 401 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
pankso@68 402 gettext "Removing Python compiled files..."
pankso@67 403 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 404 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 405 status
pankso@117 406 fi
pankso@117 407
pankso@117 408 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 409 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 410 gettext "Removing Perl compiled files..."
pankso@67 411 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 412 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 413 status
pankso@67 414 fi
pankso@1 415 }
pankso@1 416
pankso@8 417 # Remove installed deps.
pankso@8 418 remove_deps() {
pankso@8 419 # Now remove installed build deps.
pankso@113 420 diff="$CACHE/installed.cook.diff"
pankso@113 421 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 422 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 423 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 424 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 425 gettext "Removing:"
pankso@8 426 for dep in $deps
pankso@8 427 do
pankso@8 428 echo -n " $dep"
pankso@205 429 echo 'y' | tazpkg remove $dep >/dev/null
pankso@8 430 done
pankso@16 431 echo -e "\n"
pankso@113 432 # Keep the last diff for debug and info.
pankso@113 433 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 434 fi
pankso@1 435 }
pankso@1 436
pankso@1 437 # The main cook function.
pankso@1 438 cookit() {
pankso@11 439 echo "Cook: $PACKAGE $VERSION"
pankso@9 440 separator
pankso@1 441 set_paths
pankso@9 442 [ "$QA" ] && receipt_quality
pankso@44 443 cd $pkgdir
pankso@33 444 rm -rf install taz source
pankso@1 445
pankso@1 446 # Disable -pipe if less than 512Mb free RAM.
pankso@1 447 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 448 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 449 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 450 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 451 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 452 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 453 fi
pankso@1 454 unset free
pankso@1 455
pankso@232 456 # Export flags and path to be used by make and receipt.
pankso@44 457 DESTDIR=$pkgdir/install
pankso@232 458 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
pankso@1 459
pankso@126 460 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 461 # (ex: libusb-dev :: libusb).
pankso@215 462 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
pankso@215 463 touch $CACHE/installed.local $CACHE/installed.web
pankso@215 464 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 465 for dep in $BUILD_DEPENDS
pankso@1 466 do
pankso@126 467 implicit=${dep%-dev}
pankso@131 468 for i in $dep $implicit
pankso@126 469 do
pankso@131 470 if [ ! -f "$INSTALLED/$i/receipt" ]; then
paul@174 471 # Try local package first. In some cases implicit doesn't exist, ex:
paul@174 472 # libboost-dev exists but not libboost, so check if we got vers.
pankso@173 473 unset vers
pankso@198 474 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
pankso@131 475 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@215 476 echo $i-$vers.tazpkg >> $CACHE/installed.local
pankso@126 477 else
paul@227 478 # Priority to package version in wok (maybe more up-to-date)
paul@227 479 # than the mirrored one.
pankso@173 480 if [ "$vers" ]; then
pankso@202 481 if fgrep -q $i-$vers $DB/packages.list; then
pankso@215 482 echo $i >> $CACHE/installed.web
pankso@198 483 else
paul@211 484 # So package exists in wok but not available.
pankso@215 485 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
pankso@215 486 echo $i >> $CACHE/missing.dep
pankso@198 487 fi
pankso@225 488 else
pankso@225 489 # Package is not in wok but may be in repo.
pankso@225 490 if fgrep -q $i-$vers $DB/packages.list; then
pankso@225 491 echo $i >> $CACHE/installed.web
pankso@225 492 else
paul@227 493 echo "ERROR: unknown dep $i" && exit 1
pankso@225 494 fi
pankso@173 495 fi
pankso@126 496 fi
pankso@1 497 fi
pankso@126 498 done
pankso@1 499 done
pankso@225 500
pankso@215 501 # Get the list of installed packages
pankso@215 502 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@204 503
paul@211 504 # Have we a missing build dep to cook ?
pankso@215 505 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
pankso@205 506 gettext -e "Auto cook config is set : AUTO_COOK\n"
pankso@204 507 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
pankso@224 508 for i in $(uniq $CACHE/missing.dep)
pankso@204 509 do
pankso@205 510 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
pankso@204 511 tee -a $LOGS/$PACKAGE.log.$$
pankso@205 512 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
pankso@205 513 fgrep "remove: " $LOGS/$i.log && \
pankso@205 514 fgrep "Removing: " $LOGS/$i.log && echo "") | \
pankso@204 515 tee -a $LOGS/$PACKAGE.log.$$ && break
pankso@204 516 done
pankso@215 517 rm -f $CACHE/missing.dep
pankso@204 518 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
pankso@204 519 fi
pankso@204 520
paul@211 521 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
paul@211 522 # is enabled and cook fails we have ERROR in log, if no auto cook we have
pankso@204 523 # missing dep in cached file.
pankso@215 524 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
pankso@215 525 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
pankso@215 526 echo "ERROR: missing dep $nb" && exit 1
pankso@202 527 fi
pankso@215 528
pankso@215 529 # Install local packages.
pankso@215 530 cd $PKGS
pankso@224 531 for i in $(uniq $CACHE/installed.local)
pankso@215 532 do
pankso@224 533 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@215 534 tazpkg install $i >/dev/null
pankso@215 535 done
pankso@215 536
pankso@215 537 # Install web or cached packages (if mirror is set to $PKGS we only
pankso@215 538 # use local packages).
pankso@224 539 for i in $(uniq $CACHE/installed.web)
pankso@215 540 do
pankso@228 541 gettext "Installing dep (web/cache):"; echo " $i"
pankso@215 542 tazpkg get-install $i >/dev/null
pankso@215 543 done
pankso@215 544
pankso@215 545 # If a cook failed deps are removed.
pankso@215 546 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@215 547 [ ! -s "installed.cook.diff" ] && \
pankso@215 548 busybox diff installed.list installed.cook > installed.cook.diff
pankso@215 549 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@202 550
pankso@1 551 # Get source tarball and make sure we have source dir named:
paul@62 552 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 553 # tarball if it exists.
pankso@1 554 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 555 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 556 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@190 557 LZMA_SRC=""
pankso@1 558 else
pankso@1 559 get_source || exit 1
pankso@1 560 fi
pankso@1 561 fi
pankso@242 562 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 563 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pascal@268 564 if ! extract_source ; then
pascal@268 565 get_source
pascal@268 566 extract_source || exit 1
pascal@268 567 fi
pankso@190 568 if [ "$LZMA_SRC" ]; then
pankso@190 569 cd $pkgdir/source
pankso@190 570 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
pankso@190 571 mv tmp tmp-1 && mkdir tmp
pankso@190 572 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
pankso@190 573 fi
pankso@190 574 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
pankso@190 575 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
pankso@190 576 fi
pankso@190 577 fi
pankso@190 578 cd $pkgdir/source/tmp
paul@62 579 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 580 files=$(ls | wc -l)
pankso@244 581 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
pankso@244 582 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@244 583 mv * ../$PACKAGE-$VERSION/$TARBALL
pankso@57 584 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 585 mv * ../$PACKAGE-$VERSION
pankso@1 586 cd .. && rm -rf tmp
pankso@1 587 fi
pankso@1 588
pankso@9 589 # Execute receipt rules.
pankso@44 590 if grep -q ^compile_rules $receipt; then
pankso@1 591 gettext -e "Executing: compile_rules\n"
pankso@55 592 [ -d "$src" ] && cd $src
pankso@97 593 compile_rules $@ || exit 1
pankso@10 594 # Stay compatible with _pkg
pankso@55 595 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 596 # QA: compile_rules success so valid.
pankso@9 597 mkdir -p $install
pankso@9 598 else
pankso@9 599 # QA: No compile_rules so no error, valid.
pankso@9 600 mkdir -p $install
pankso@1 601 fi
pankso@1 602 separator && echo ""
pankso@1 603 }
pankso@1 604
pankso@1 605 # Cook quality assurance.
pankso@1 606 cookit_quality() {
pankso@9 607 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 608 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 609 fi
pankso@9 610 # ERROR can be echoed any time in cookit()
pankso@33 611 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 612 debug_info | tee -a $LOGS/$pkg.log
pankso@33 613 rm -f $command && exit 1
pankso@1 614 fi
pankso@1 615 }
pankso@1 616
pankso@16 617 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 618 # but it doesn't handle EXTRAVERSION.
pankso@1 619 packit() {
pankso@1 620 set_paths
pankso@55 621 echo "Pack: $PACKAGE $VERSION"
pankso@1 622 separator
pankso@44 623 if grep -q ^genpkg_rules $receipt; then
pankso@16 624 gettext -e "Executing: genpkg_rules\n"
pankso@259 625 set -e && cd $pkgdir && mkdir -p $fs
pankso@232 626 genpkg_rules || echo -e "\nERROR: genpkg_rules failed\n" >> \
pankso@234 627 $LOGS/$pkg.log
pankso@241 628 else
pankso@241 629 gettext "No packages rules: meta package"; echo
pankso@241 630 mkdir -p $fs
pankso@16 631 fi
pankso@98 632
pankso@98 633 # First QA check to stop now if genpkg_rules failed.
pankso@98 634 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 635 exit 1
pankso@98 636 fi
pankso@98 637
pankso@44 638 cd $taz
pankso@1 639 for file in receipt description.txt
pankso@1 640 do
pankso@1 641 [ ! -f "../$file" ] && continue
pankso@1 642 gettext "Copying"; echo -n " $file..."
pankso@1 643 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 644 done
pankso@119 645 copy_generic_files
pankso@16 646
paul@62 647 # Create files.list with redirecting find output.
pankso@16 648 gettext "Creating the list of files..." && cd $fs
pankso@16 649 find . -type f -print > ../files.list
pankso@16 650 find . -type l -print >> ../files.list
pankso@16 651 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 652 status
pankso@43 653
pankso@119 654 # Strip and stuff files.
pankso@43 655 strip_package
pankso@43 656
pankso@43 657 # Md5sum of files.
pankso@16 658 gettext "Creating md5sum of files..."
pankso@16 659 while read file; do
pankso@16 660 [ -L "fs$file" ] && continue
pankso@16 661 [ -f "fs$file" ] || continue
pankso@16 662 case "$file" in
pankso@232 663 /lib/modules/*/modules.*|*.pyc) continue ;;
pankso@16 664 esac
pankso@16 665 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 666 done < files.list > md5sum
pankso@16 667 status
pankso@16 668 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 669 description.txt 2> /dev/null | awk \
pankso@16 670 '{ sz=$1 } END { print sz }')
pankso@16 671
pankso@16 672 # Build cpio archives.
pankso@16 673 gettext "Compressing the fs... "
pankso@16 674 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 675 rm -rf fs
pankso@16 676 status
pankso@16 677 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 678 md5sum description.txt 2> /dev/null | awk \
pankso@16 679 '{ sz=$1 } END { print sz }')
pankso@16 680 gettext "Updating receipt sizes..."
pankso@16 681 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 682 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 683 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 684 status
pankso@16 685
pankso@16 686 # Set extra version.
pankso@16 687 if [ "$EXTRAVERSION" ]; then
pankso@16 688 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 689 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 690 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 691 status
pankso@16 692 fi
pankso@16 693
pankso@16 694 # Compress.
pankso@16 695 gettext "Creating full cpio archive... "
pankso@16 696 find . -print | cpio -o -H newc --quiet > \
pankso@16 697 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 698 status
pankso@16 699 gettext "Restoring original package tree... "
pankso@16 700 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 701 status
pankso@16 702 rm fs.cpio.lzma && cd ..
pankso@43 703
pankso@43 704 # QA and give info.
pankso@43 705 tazpkg=$(ls *.tazpkg)
pankso@43 706 packit_quality
pankso@43 707 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 708 }
pankso@1 709
paul@62 710 # Verify package quality and consistency.
pankso@8 711 packit_quality() {
pankso@157 712 #gettext "QA: Checking for broken link..."
pankso@157 713 #link=$(find $fs/usr -type l -follow)
pankso@157 714 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@157 715 #status
pankso@142 716
pankso@142 717 # Exit if any error found in log file.
pankso@33 718 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 719 rm -f $command && exit 1
pankso@8 720 fi
pankso@142 721
pankso@44 722 gettext "QA: Checking for empty package..."
pankso@45 723 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@259 724 if [ "$files" == 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 725 echo -e "\nERROR: empty package"
pankso@32 726 rm -f $command && exit 1
pankso@8 727 else
pankso@134 728 # Ls sort by name so the first file is the one we want.
pankso@136 729 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 730 status
pankso@154 731 if [ -f "$old" ]; then
pankso@265 732 gettext "Removing old: $(basename $old)"
pankso@135 733 rm -f $old && status
pankso@154 734 fi
pankso@134 735 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 736 sed -i /^${pkg}$/d $broken
pankso@265 737 #gettext "Removing source tree..."
pankso@265 738 #rm -f $WOK/$pkg/source && status
pankso@8 739 fi
pankso@8 740 }
pankso@8 741
pascal@276 742 mkinstall_list() {
pascal@276 743 local pkg
pascal@276 744 for pkg in $@ ; do
pascal@276 745 case " $INSTALL_LIST " in
pascal@278 746 *\ $pkg\ *) continue ;;
pascal@279 747 *) if [ -s /home/slitaz/wok/$pkg/receipt ]; then
pascal@279 748 unset DEPENDS
pascal@279 749 . /home/slitaz/wok/$pkg/receipt
pascal@279 750 INSTALL_LIST="$INSTALL_LIST $pkg"
pascal@279 751 [ -n "$DEPENDS" ] && mkinstall_list $DEPENDS
pascal@279 752 fi
pascal@279 753 echo $pkg
pascal@276 754 esac
pascal@276 755 done
pascal@276 756 }
pascal@276 757
pankso@1 758 #
pankso@1 759 # Commands
pankso@1 760 #
pankso@1 761
pankso@1 762 case "$1" in
pankso@32 763 usage|help|-u|-h)
pankso@1 764 usage ;;
pankso@1 765 list-wok)
pankso@52 766 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 767 separator
pankso@1 768 cd $WOK && ls -1
pankso@1 769 separator
pankso@1 770 echo -n "Packages: " && ls | wc -l
pankso@1 771 echo "" ;;
pankso@69 772 search)
pankso@69 773 # Just a simple search function, we dont need more actually.
pankso@69 774 query="$2"
pankso@69 775 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 776 separator
pankso@69 777 cd $WOK && ls -1 | grep "$query"
pankso@69 778 separator && echo "" ;;
pankso@1 779 setup)
pankso@1 780 # Setup a build environment
pankso@1 781 check_root
pankso@11 782 echo "Cook: setting up the environment" | log
pankso@1 783 gettext -e "\nSetting up your environment\n"
pankso@1 784 separator && cd $SLITAZ
pankso@52 785 init_db_files
pankso@1 786 gettext -e "Checking for packages to install...\n"
pascal@276 787 case " $@ " in
pascal@276 788 *\ --reinstall\ *)
pascal@276 789 INSTALL_LIST=""
pascal@276 790 for pkg in $(mkinstall_list $SETUP_PKGS); do
pascal@276 791 tazpkg get-install $pkg --forced
pascal@276 792 done ;;
pascal@276 793 *)
pascal@276 794 for pkg in $SETUP_PKGS
pascal@276 795 do
pascal@276 796 [ ! -f "$INSTALLED/$pkg/receipt" ] &&
pascal@276 797 tazpkg get-install $pkg
pascal@276 798 done ;;
pascal@276 799 esac
pankso@1 800
pankso@1 801 # Handle --options
pankso@1 802 case "$2" in
pankso@49 803 --wok|-w)
pankso@230 804 hg clone $WOK_URL wok || exit 1 ;;
pankso@230 805 --stable)
pankso@230 806 hg clone $WOK_URL-stable wok || exit 1 ;;
pankso@230 807 --undigest)
pankso@230 808 hg clone $WOK_URL-undigest wok || exit 1 ;;
pankso@1 809 esac
pankso@1 810
pankso@1 811 # SliTaz group and permissions
pankso@1 812 if ! grep -q ^slitaz /etc/group; then
pankso@1 813 gettext -e "Adding group: slitaz\n"
pankso@1 814 addgroup slitaz
pankso@1 815 fi
pankso@1 816 gettext -e "Setting permissions for slitaz group...\n"
pascal@277 817 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
pascal@277 818 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
pankso@1 819 separator
pankso@1 820 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 821 test)
pankso@9 822 # Test a cook environment.
pankso@13 823 echo "Cook test: testing the cook environment" | log
pankso@9 824 [ ! -d "$WOK" ] && exit 1
pankso@9 825 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 826 cook cooktest ;;
pankso@1 827 new)
pankso@1 828 # Create the package folder and an empty receipt.
pankso@1 829 pkg="$2"
pankso@1 830 [ "$pkg" ] || usage
pankso@1 831 echo ""
pankso@1 832 if [ -d "$WOK/$pkg" ]; then
paul@62 833 echo -n "$pkg " && gettext "package already exists."
pankso@1 834 echo -e "\n" && exit 1
pankso@1 835 fi
pankso@1 836 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 837 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 838 gettext "Preparing the package receipt..."
pankso@1 839 cp $DATA/receipt .
pankso@1 840 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@196 841 status && echo ""
pankso@196 842
pankso@196 843 # Interactive mode, asking and seding.
pankso@196 844 case "$3" in
paul@214 845 --interactive|-x)
paul@211 846 gettext -e "Entering interactive mode...\n"
paul@211 847 separator
pankso@196 848 echo "Package : $pkg"
pankso@196 849 # Version.
pankso@196 850 echo -n "Version : " ; read anser
pankso@196 851 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
pankso@196 852 # Category.
pankso@196 853 echo -n "Category : " ; read anser
pankso@196 854 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
pankso@196 855 # Short description.
pankso@196 856 echo -n "Short desc : " ; read anser
pankso@196 857 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
pankso@196 858 # Maintainer.
pankso@196 859 echo -n "Maintainer : " ; read anser
pankso@196 860 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
pankso@196 861 # Web site.
pankso@196 862 echo -n "Web site : " ; read anser
pankso@196 863 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
pankso@196 864 echo ""
pankso@196 865 # Wget URL.
pankso@196 866 echo "Wget URL to download source tarball."
pankso@196 867 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
pankso@196 868 echo -n "Wget url : " ; read anser
paul@211 869 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
pankso@196 870 # Ask for a stuff dir.
pankso@196 871 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
pankso@196 872 if [ "$anser" = "y" ]; then
pankso@196 873 echo -n "Creating the stuff directory..."
pankso@196 874 mkdir $WOK/$pkg/stuff && status
pankso@196 875 fi
pankso@196 876 # Ask for a description file.
pankso@196 877 echo -n "Are you going to write a description ? (y/N) : " ; read anser
pankso@196 878 if [ "$anser" = "y" ]; then
pankso@196 879 echo -n "Creating the description.txt file..."
pankso@196 880 echo "" > $WOK/$pkg/description.txt && status
pankso@196 881 fi
paul@211 882 separator
paul@211 883 gettext -e "Receipt is ready to use.\n"
pankso@196 884 echo "" ;;
pankso@196 885 esac ;;
pankso@1 886 list)
pankso@1 887 # Cook a list of packages (better use the Cooker since it will order
pankso@1 888 # packages before executing cook).
pankso@1 889 check_root
pankso@1 890 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 891 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 892 echo -e " $2\n" && exit 1
pankso@13 893 echo "Cook list starting: $2" | log
pankso@1 894 for pkg in $(cat $2)
pankso@1 895 do
pankso@1 896 cook $pkg || broken
pankso@1 897 done ;;
pankso@1 898 clean-wok)
pankso@1 899 check_root
pankso@1 900 gettext -e "\nCleaning all packages files..."
pankso@1 901 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 902 status && echo "" ;;
pankso@1 903 clean-src)
pankso@1 904 check_root
paul@62 905 gettext -e "\nCleaning all packages sources..."
pankso@1 906 rm -rf $WOK/*/source
pankso@1 907 status && echo "" ;;
pankso@235 908 pkgdb)
pankso@235 909 # Create suitable packages list for TazPKG and only for built packages
pankso@235 910 # as well as flavors files for TazLiTo. We dont need logs since we do it
paul@243 911 # manually to ensure everything is fine before syncing the mirror.
pankso@239 912 case "$2" in
pankso@239 913 --flavors)
pankso@239 914 continue ;;
pankso@239 915 *)
pankso@240 916 [ "$2" ] && PKGS="$2"
pankso@239 917 [ ! -d "$PKGS" ] && \
pankso@240 918 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1 ;;
pankso@239 919 esac
pankso@226 920 time=$(date +%s)
pankso@239 921 flavors=$SLITAZ/flavors
pankso@239 922 live=$SLITAZ/live
pankso@235 923 echo "cook:pkgdb" > $command
pankso@235 924 echo "Cook pkgdb: Creating all packages lists" | log
pankso@235 925 echo ""
pankso@239 926 gettext "Creating lists for: "; echo "$PKGS"
pankso@1 927 separator
pankso@235 928 gettext "Cook pkgdb started: "; date "+%Y-%m-%d %H:%M"
pankso@133 929 cd $PKGS
pankso@192 930 rm -f packages.*
pankso@235 931 gettext -e "Creating: packages.list\n"
pankso@85 932 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@235 933 gettext -e "Creating: packages.md5\n"
pankso@1 934 md5sum *.tazpkg > $PKGS/packages.md5
pankso@235 935 gettext -e "Creating lists from: "; echo "$WOK"
pankso@1 936 cd $WOK
pankso@1 937 for pkg in *
pankso@1 938 do
pankso@1 939 unset_receipt
pankso@1 940 . $pkg/receipt
pankso@1 941 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pascal@267 942 # PACKED_SIZE and UNPACKED_SIZE are only in built receipt
pascal@274 943 if [ -s $pkg/taz/*/receipt ]; then
pascal@274 944 . $pkg/taz/*/receipt
pascal@274 945 fi
pankso@192 946 # packages.desc lets us search easily in DB
pankso@1 947 cat >> $PKGS/packages.desc << EOT
pankso@235 948 $PACKAGE | ${VERSION}$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 949 EOT
pankso@192 950 # packages.txt used by tazpkg and tazpkg-web also to provide
pankso@192 951 # a human readable package list with version and description.
pankso@192 952 cat >> $PKGS/packages.txt << EOT
pankso@192 953 $PACKAGE
pankso@235 954 ${VERSION}$EXTRAVERSION
pankso@235 955 $SHORT_DESC
pankso@235 956 $PACKED_SIZE ($UNPACKED_SIZE installed)
pankso@235 957
pankso@192 958 EOT
pankso@192 959 # packages.equiv is used by tazpkg install to check depends.
pankso@1 960 for i in $PROVIDE; do
pankso@1 961 DEST=""
pankso@1 962 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 963 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 964 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 965 $PKGS/packages.equiv
pankso@1 966 else
pankso@1 967 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 968 fi
pankso@1 969 done
paul@197 970 # files.list provides a list of all packages files.
pankso@194 971 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
pankso@194 972 $PKGS/files.list
pankso@1 973 fi
pankso@1 974 done
pankso@235 975
pankso@213 976 # Display list size.
pankso@235 977 gettext -e "Done: packages.desc\n"
pankso@235 978 gettext -e "Done: packages.txt\n"
pankso@235 979 gettext -e "Done: packages.equiv\n"
pankso@155 980
pankso@194 981 # files.list.lzma
pankso@235 982 gettext -e "Creating: files.list.lzma\n"
pankso@235 983 cd $PKGS && lzma e files.list files.list.lzma
pankso@194 984 rm -f files.list
pankso@148 985
pankso@235 986 # Display some info.
pankso@1 987 separator
pankso@1 988 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@226 989 time=$(($(date +%s) - $time))
pankso@235 990 echo -e "Packages: $nb - Time: ${time}s\n"
pankso@235 991
paul@243 992 # Create all flavors files at once. Do we really need code to monitor
paul@243 993 # flavors changes ? Lets just build them with packages lists before
pankso@235 994 # syncing the mirror.
pankso@239 995 [ "$2" == "--flavors" ] || exit 1
pankso@239 996 [ ! -d "$flavors" ] && echo -e "Missing flavors: $flavors\n" && exit 1
pankso@239 997 [ -d "$live" ] || mkdir -p $live
pankso@236 998 gettext "Creating flavors files in:"; echo " $live"
pankso@239 999 echo "Cook pkgdb: Creating all flavors" | log
pankso@235 1000 separator
pankso@236 1001 gettext -e "Recharging lists to use latest packages...\n"
pankso@239 1002 tazpkg recharge 2>1 >/dev/null
pankso@235 1003
pankso@235 1004 # We need a custom tazlito config to set working dir to /home/slitaz.
pankso@235 1005 if [ ! -f "$live/tazlito.conf" ]; then
pankso@235 1006 echo "Creating configuration file: tazlito.conf"
pankso@235 1007 cp /etc/tazlito/tazlito.conf $live
pankso@235 1008 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
pankso@235 1009 $live/tazlito.conf
pankso@235 1010 fi
pankso@235 1011
pankso@239 1012 # Update Hg flavors repo and pack.
pankso@239 1013 [ -d "$flavors/.hg" ] && cd $flavors && hg pull -u
pankso@239 1014
pankso@239 1015 cd $live
pankso@235 1016 echo "Starting to generate flavors..."
pankso@235 1017 rm -f flavors.list *.flavor
pankso@235 1018 for i in $flavors/*
pankso@235 1019 do
pankso@235 1020 fl=$(basename $i)
pankso@235 1021 echo "Packing flavor: $(basename $i)"
pankso@235 1022 tazlito pack-flavor $fl >/dev/null || exit 1
pankso@235 1023 tazlito show-flavor $fl --brief --noheader 2> \
pankso@235 1024 /dev/null >> flavors.list
pankso@235 1025 done
pankso@237 1026 cp -f $live/*.flavor $live/flavors.list $PKGS
pankso@235 1027 separator && gettext "Flavors size: "; du -sh $live | awk '{print $1}'
pankso@235 1028 echo "" && rm -f $command ;;
pankso@1 1029 *)
pankso@1 1030 # Just cook and generate a package.
pankso@1 1031 check_root
pankso@1 1032 time=$(date +%s)
pankso@1 1033 pkg="$1"
pankso@1 1034 [ -z "$pkg" ] && usage
pankso@44 1035 receipt="$WOK/$pkg/receipt"
pankso@1 1036 check_pkg_in_wok && echo ""
pankso@47 1037
pankso@128 1038 # Display and log info if cook process stopped.
pankso@128 1039 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 1040 tee -a $LOGS/$pkg.log' INT
pankso@128 1041
pankso@47 1042 # Skip blocked, 3 lines also for the Cooker.
pankso@151 1043 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
pankso@47 1044 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 1045 fi
pankso@47 1046
pankso@47 1047 # Log and source receipt.
pankso@56 1048 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 1049 echo "cook:$pkg" > $command
pankso@1 1050 unset inst
pankso@1 1051 unset_receipt
pankso@44 1052 . $receipt
pankso@1 1053
pankso@1 1054 # Handle --options
pankso@1 1055 case "$2" in
pankso@1 1056 --clean|-c)
pankso@49 1057 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 1058 cd $WOK/$pkg && rm -rf install taz source
pankso@1 1059 status && echo "" && exit 0 ;;
pankso@1 1060 --install|-i)
pankso@1 1061 inst='yes' ;;
pankso@49 1062 --getsrc|-gs)
pankso@49 1063 gettext "Getting source for:"; echo " $pkg"
pankso@45 1064 separator && get_source
pankso@39 1065 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 1066 --block|-b)
pankso@49 1067 gettext "Blocking:"; echo -n " $pkg"
pankso@49 1068 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 1069 status && echo "" && exit 0 ;;
pankso@49 1070 --unblock|-ub)
pankso@49 1071 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 1072 sed -i "/^${pkg}$/"d $blocked
pankso@49 1073 status && echo "" && exit 0 ;;
pankso@196 1074
pankso@1 1075 esac
pankso@1 1076
paul@62 1077 # Check if wanted is built now so we have separate log files.
pankso@218 1078 if [ "$WANTED" ]; then
pankso@217 1079 if grep -q "^$WANTED$" $blocked; then
pankso@221 1080 echo "WANTED package is blocked: $WANTED" | tee $LOGS/$pkg.log
pankso@221 1081 echo "" && rm -f $command && exit 1
pankso@217 1082 fi
pankso@217 1083 if grep -q "^$WANTED$" $broken; then
pankso@221 1084 echo "WANTED package is broken: $WANTED" | tee $LOGS/$pkg.log
pankso@221 1085 echo "" && rm -f $command && exit 1
pankso@218 1086 fi
pankso@218 1087 if [ ! -d "$WOK/$WANTED/install" ]; then
pankso@217 1088 cook "$WANTED" || exit 1
pankso@137 1089 fi
pankso@1 1090 fi
pankso@1 1091
pankso@1 1092 # Cook and pack or exit on error and log everything.
pankso@97 1093 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 1094 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 1095 cookit_quality
pankso@26 1096 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 1097 clean_log
pankso@33 1098
pankso@33 1099 # Exit if any error in packing.
pankso@33 1100 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 1101 debug_info | tee -a $LOGS/$pkg.log
pankso@33 1102 rm -f $command && exit 1
pankso@33 1103 fi
pankso@16 1104
pankso@1 1105 # Time and summary
pankso@1 1106 time=$(($(date +%s) - $time))
pankso@1 1107 summary | tee -a $LOGS/$pkg.log
pankso@50 1108 echo ""
pankso@1 1109
pankso@1 1110 # Install package if requested
pankso@1 1111 if [ "$inst" ]; then
pankso@1 1112 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 1113 cd $PKGS && tazpkg install \
pankso@1 1114 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 1115 else
paul@62 1116 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 1117 exit 1
pankso@1 1118 fi
pankso@1 1119 fi
pankso@9 1120 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 1121 # You want automation: use the Cooker Build Bot.
pankso@1 1122 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 1123 rm -f $command ;;
pankso@1 1124 esac
pankso@1 1125
pankso@1 1126 exit 0